#include "date.au3"

Global $oMyError = ObjEvent("AutoIt.Error", "MyErrFunc1")

$strdebug = ""
$debug = 5
$err = 0
$fhlog = FileOpen(@TempDir & "\phoner.log", 1)
$myCall = 0 ; Callid
$mynumber = "meine Nummer"

; Startet Phoner und gibt Object zurck
$obj = PhonerInit()


; Sendet entweder zwei Wrter aus der Komandozeile oder "Testalarm"
If $CMdline[0] > 0 Then
	$msgtext = $CMdline[1] & @CRLF & $CMdline[2]
Else
	$msgtext = "Testalarm"
EndIf

; Um Uhrzeit erweitern und auf 160 Zeichen krzen
$msgtext = StringLeft(_Now() & @CRLF & $msgtext, 160)

ConsoleWrite("Text: " & $msgtext & @CRLF)

; Eine SMS an die oben definierte Nummer senden
$obj.SendSMS ($mynumber, $msgtext)

;Pause weil verzgert gesendet wird
Sleep(3000)

; Warten das die Verbindung wirklich fertig ist und Phoner beenden
PhonerQuit()

Exit

Func Debug($level, $str)
	If $err > 0 Then
		$str = "Error (" & $err & ") => " & $str
	EndIf
	FileWriteLine($fhlog, $str);
	If $level <= $debug Then
		ConsoleWrite($level & ": " & $str & @LF)
	EndIf
	$strdebug = $strdebug & $level & ": " & $str & @LF
EndFunc   ;==>Debug


Func PhonerQuit()
	Sleep(5000)
	While $obj.NumberofCalls > 0 ; Sind npoch Leitungen offen?
		Sleep(500)
	WEnd
	ProcessClose("Phoner.exe")
EndFunc   ;==>PhonerQuit

Func PhonerInit()
	If Not ProcessExists("Phoner.exe") Then
		$str = RegRead("HKCR\CLSID\{98898145-96E2-11D3-A1D0-444553540000}\LocalServer32", "")
		ConsoleWrite($str & @CRLF)
		Run($str) ; EXE-Pfad aus Registry auslesen und starten
		For $i = 0 To 10
			If ProcessExists("Phoner.exe") Then ; gegebenenfalls 5 Sekunden warten
				ExitLoop
			Else
				Sleep(500)
			EndIf
		Next
		
		If Not ProcessExists("Phoner.exe") Then ; Bei Problemen Skript beenden
			ConsoleWrite("Phoner konnte nicht gestartet werden" & @CRLF)
			Exit (1)
		EndIf
		; Alles OK dann Object erzeugen
		$obj = ObjCreate("Phoner.CPhoner")
		$myPhonerEvent = ObjEvent($obj, "Phoner_")

		$obj.WindowEnabled = False
		Return $obj
	EndIf
	
EndFunc   ;==>PhonerInit

Func Phoner_OnChangeState($CallID)
	Dim $Status, $direction, $calledid, $callerid, $str
	$myCall = $CallID
	; Hier kann nur die eigene CallID ermittelt werden, der REst geht nicht mit autoit 
	ConsoleWrite("CallID: " & $myCall & "-> " & $str & "status: " & $Status & "direction: " & "Callerid:" & $callerid & "CalledID: " & $calledid & @CRLF)
EndFunc   ;==>Phoner_OnChangeState

Func MyErrFunc1()
	$HexNumber = Hex($oMyError.number, 8)
	Debug(1, "COM Error ! desc: " & $oMyError.description & " windesc" & @TAB & $oMyError.windescription & @CRLF & _
			"err.number is: " & @TAB & $HexNumber & @CRLF & _
			"err.lastdllerror is: " & @TAB & $oMyError.lastdllerror & @CRLF & _
			"err.scriptline is: " & @TAB & $oMyError.scriptline & @CRLF & _
			"err.source is: " & @TAB & $oMyError.source & @CRLF & _
			"err.helpcontext is: " & @TAB & $oMyError.helpcontext _
			)
EndFunc   ;==>MyErrFunc1